;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Yoshi Trigger
;;
;; Description: This should set Ex-Animation custom trigger 0 if Mario is riding Yoshi,
;; and clear it if he is not.
;;
;; Uses first extra bit: NO
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    PRINT "INIT ",pc              ;generators don't have an init routine
                    PRINT "MAIN ",pc                                    
                    PHB                     
                    PHK                     
                    PLB                     
                    JSR SPRITE_CODE_START   
                    PLB                     
                    RTL      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_CODE_START: 	LDA $187A	; load 'riding Yoshi' flag    
			CMP #$00	; compare with 0 (not riding Yoshi)
			BEQ NO_YOSHI	; if equal, branch to NO_YOSHI
			BRA YOSHI	; otherwise, jump to YOSHI

NO_YOSHI:		REP #$20
			LDA $7FC0FC
			AND #$FFFE
			STA $7FC0FC
			SEP #$20
			BRA RETURN

YOSHI:			REP #$20
			LDA $7FC0FC
			ORA #$0001
			STA $7FC0FC
			SEP #$20
			BRA RETURN

RETURN:			RTS